\tikzstyle{ast} = [circle,draw=alum-6,fill=alum-1]
\tikzstyle{big-ast} = [ast, text width=3.5em, text centered]
\tikzstyle{code} = [big-ast, fill=cham-2!20]
\tikzstyle{test} = [big-ast, fill=plum-3!20]
\tikzstyle{type} = [big-ast, fill=choc-1!20]
\tikzstyle{prose} = [big-ast, fill=cyan!20]

\tikzstyle{big-lang} = [circle, opacity=0.6, text width=8em, text centered]
\tikzstyle{js} = [big-lang, fill=cham-2!20]
\tikzstyle{py} = [big-lang, fill=plum-3!20]
\tikzstyle{cl} = [big-lang, fill=choc-1!20]

\begin{tikzpicture}[sibling distance=2em, level distance=1.25em]
  \node [ast] (asts) {}
  child { node [ast] (asts-left) {}}
  child { node [ast] {} {
      child { node [ast] {}{
          child { node [ast] {}}
          child { node [ast] {} {
              child { node [ast] (asts-bottom) {}}}}}}
      child { node [ast] (asts-right) {}}}};

  \node[code, right=8em of asts-right] (code) {Code};
  \node[test, below left=1.5em and 1.5em of code] (test) {Test};
  \node[below=0.5em of test.center] {$\exists$};
  \node[type, below right=1.5em and 1.5em of code] (type) {Type};
  \node[below=0.5em of type.center] {$\forall$};
  \node[prose, below=5em of code] (prose) {Prose};
  %% \node[core, above=1em of code] (core) {Core};

  \draw[dotted] (asts-right.north) to (code.north);
  \draw[dotted] (asts-right.south) to (test.west);

  \draw[<->,thick] (code) to (test);
  \draw[<->,thick] (test) to (type);
  \draw[<->,thick] (type) to (code);
  \draw[<->,thick] (code) to (prose);
  \draw[<->,thick] (type) to (prose);
  \draw[<->,thick] (test) to (prose);
  %% \draw[dotted,thick] (code) to (core);

  %% \node[below=1.5em of code, color=gt@gray] (synth) {Synthesis};
  %% \draw[->,thick,bend right, color=gt@gray] ($(synth.40) + (0.25em,0.25em)$) to ($(synth.140) + (-0.25em,0.25em)$);
  %% \draw[->,thick,bend right, color=gt@gray] ($(synth.220) + (-0.25em,-0.25em)$) to ($(synth.320) + (0.25em,-0.25em)$);

  %% \node[right=12em of core] (intersection) {Core};
  %% \node[js, above=-1em of intersection.center] (js) {JavaScript};
  %% \node[py, below right=-1.5em and -3em of js] (py) {Python};
  %% \node[cl, below left=-1.5em and -3em of js] (cl) {Common\\Lisp};
  %% \node at (intersection) {Core};

  %% \draw[dotted,thick] (core) to (intersection);

\end{tikzpicture}
